require 'rest-client'
require 'json'

module Capistrano
  module Rocketdeploy
    class Client

      def initialize(base_url, token)
        puts "rocketdeploy base url: #{base_url}"
        @base_url = base_url
        @token = token
      end

      def deploy_started(params)
        post("", params)
      end

      def deploy_finished(deploy_id)
        post("/#{deploy_id}/finished")
      end

      def deploy_failed(deploy_id)
        post("/#{deploy_id}/failed")
      end

      private
      def post(url, params = {})
        resp = RestClient.post(
          "#{@base_url}api/deploys#{url}",
          JSON.dump(params),
          {
            content_type: :json,
            accept: :json,
            'Access-Token' => @token,
          }
        )
        JSON.parse(resp)
      rescue Exception => e
        puts "RocketDeploy error: #{e.class.name}: #{e.message}"
        puts e.backtrace[0..10].join("\n")
        nil
      end
    end
  end
end

